import React from 'react';
import { Theme } from '@storybook/theming';
import { TestResult } from '../../../types';
interface TestResultsProps {
    id: string;
    path: string[];
    results?: TestResult[];
    approved?: Partial<{
        [image: string]: number;
    }>;
    showTitle?: boolean;
    onImageApprove: (id: string, retry: number, image: string) => void;
    theme: Theme;
    height?: string;
}
export declare function ResultsPageInternal({ id, path, results, approved, theme, onImageApprove, showTitle, height, }: TestResultsProps): JSX.Element;
export declare const ResultsPage: React.FC<Pick<TestResultsProps, "id" | "results" | "path" | "height" | "approved" | "showTitle" | "onImageApprove"> & {
    theme?: Theme | undefined;
}>;
export {};
